Bug 353261 - VUL-0: Apache2 CSRF, XSS, Memory Corruption and Denial of Service Vulnerability
VUL-0: Apache2 CSRF, XSS, Memory Corruption and Denial of Service Vulnerabi...
Status: RESOLVED FIXED
Classification: openSUSE
Product: openSUSE 10.3
Classification: openSUSE
Component: Security
Final
Other Other
: P5 - None : Major (vote)
: ---
Assigned To: Sonja Krause-Harder
E-mail List
CVE-2007-6424: CVSS v2 Base Score: 4....
:
Depends on:
Blocks: 355888
  Show dependency treegraph
 
Reported: 2008-01-11 16:14 UTC by Ludwig Nussel
Modified: 2009-10-14 00:27 UTC (History)
1 user (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ludwig Nussel 2008-01-11 16:14:51 UTC
Date: Fri, 11 Jan 2008 00:40:14 +0100
From: "sp3x" <sp3x@securityreason.com>
To: full-disclosure@lists.grok.org.uk
Subject: [Full-disclosure] SecurityReason - Apache2 CSRF, XSS,
 Memory Corruption and  Denial of Service Vulnerability

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

[Apache2 CSRF, XSS, Memory Corruption and Denial of Service Vulnerability ]

Author: sp3x

Date:
- - Written: 06.12.2007
- - Public: 09.01.2008

SecurityReason Research
SecurityAlert Id: 48

CVE: CVE-2007-6420
     CVE-2007-6421
     CVE-2007-6422
     CVE-2007-6423

SecurityRisk: Low

Affected Software: Apache 2.2.x (mod_proxy_balancer)
Advisory URL:
http://securityreason.com/achievement_securityalert/48
Vendor: http://httpd.apache.org

- --- 0.Description ---

The Apache HTTP Server Project is an effort to develop and maintain an open-source HTTP server for modern operating systems including UNIX and Windows NT. The goal of this project is to provide a secure, efficient and extensible server that provides HTTP services in sync with the current  HTTP standards.

Apache has been the most popular web server on the Internet since April 1996. The November 2005 Netcraft Web Server Survey found that more than 70% of the web sites on the Internet are using Apache, thus making it more widely used than all other web servers combined.

mod_proxy_balancer : http://httpd.apache.org/docs/2.2/mod/mod_proxy_balancer.html

- From apache site : "Balancer manager enables dynamic update of balancer members. You can use balancer manager to change the balance factor or a particular member, or put it in the off line mode"

balancer-manager is an administrative interface which should only be accessible to trusted users. Due to the fact the SecurityRisk is Low.

- --- 1. Apache2 Cross-Site Request Forgery (CSRF) Vulnerability ---

During the fact that all actions are performed by GET method there exist "CSRF" .

The balancer-manager should use POST for requests which have side-effects 
which would significantly mitigate the "CSRF" issue.

- --- 2. Apache2 HTML Injection (XSS) Vulnerability ---

- --- First XSS ---

The HTML Injection (XSS) vulnerability exist in "mod_proxy_balancer.c" .

By Enabling Balancer Manager Support we can trigger XSS vulnerability . 

Input passed to the :
"ss" - called ""StickySession Identifier",  
"wr" - called "Route",
"rr" - called "Route Redirect", 
parametrs in balancer-manager are not properly sanitised leading to execute arbitrary HTML and script code in a victim's browser.

- --- Second XSS ---

Input passed in the URL to "balancer-mamanger" is not properly sanitised leading to execute arbitrary HTML and script code in a victim's browser.


- --- 3. Apache2 Denial of Service Vulnerability ---

The Denial of Service is caused due to an error in the "balancer_handler()" function that manages the loadfactors and member status. When attacker input invalid "bb" variable while editing worker settings leads to "Denial of Service Vulnerability".

- --- 4. Apache2 Memory Corruption ---

The Memory corruption is caused due to an error in the "mod_proxy_balancer" when attacker input in the URL 7390 or 7506 or 7622 "A" chars.

Only for Windows.

- --- 4. Exploit ---

SecurityReason is not going to release a exploit to the general public.
Exploit was provided and tested for Apache Team .

- --- 5. How to fix ---

Update to Apache 2.2.7-dev

http://httpd.apache.org/security/vulnerabilities_22.html

- --- 6. References ---

CSRF : http://www.owasp.org/index.php/Testing_for_CSRF

- --- 7. Greets ---

For: Maksymilian Arciemowicz ( cXIb8O3 ), Infospec, pi3, p_e_a, mpp

- --- 8. Contact ---

Author: sp3x
Email: sp3x [at] securityreason [dot] com
GPG: http://securityreason.com/key/sp3x.gpg
http://securityreason.com
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.7 (GNU/Linux)

iD8DBQFHhUo6haZ93YsJSwQRAuYmAKCF5gOZ4P804moV5ybi8yjpbnvqNwCeNr9O
+2Taez4t5p+5O7BZ9Yol2eg=
=v0YB
-----END PGP SIGNATURE-----


_______________________________________________
Full-Disclosure - We believe in it.
Charter: http://lists.grok.org.uk/full-disclosure-charter.html
Hosted and sponsored by Secunia - http://secunia.com/
Comment 1 Sonja Krause-Harder 2008-02-28 10:59:33 UTC
Tracked in #355888
Comment 2 Marcus Meissner 2008-03-11 15:21:27 UTC
Date: Tue, 11 Mar 2008 14:41:27 +0000
From: Joe Orton <jorton@apache.org>
To: Marcus Meissner <meissner@suse.de>
Cc: security@httpd.apache.org, Sonja Krause-Harder <skh@suse.de>
Subject: Re: CVE-2007-6420
Mail-Followup-To: Marcus Meissner <meissner@suse.de>,
        security@httpd.apache.org, Sonja Krause-Harder <skh@suse.de>
User-Agent: Mutt/1.5.17 (2007-11-01)

On Tue, Mar 11, 2008 at 02:19:52PM +0100, Marcus Meissner wrote:
> I just stumbled across CVE-2007-6420, a cross site request forgery
> in mod_proxy_balancer, and wonder if you plan to issue updates for
> it, or at least have a statement on whether it will be fixed or not.

We hadn't come up with any simple way to fix this type of issue when it
came up originally, but it occurred to me recently that a simple fix is
actually possible.  I've posted this for review:

http://marc.info/?l=apache-httpd-dev&m=120524545031664&w=2

joe
Comment 3 Marcus Meissner 2008-03-11 15:22:03 UTC
(not yet final patch I guess)
Comment 4 Sonja Krause-Harder 2008-03-25 17:16:59 UTC
Fixed in 10.3, 10.2, 10.1/sles10, n/a for sles9 (2.2.x only).

Packages submitted, further tracking in bug #355888.
Comment 5 Ludwig Nussel 2008-03-26 08:31:14 UTC
You have fixed CVE-2007-6421 and CVE-2007-6422.
What about CVE-2007-6420 and CVE-2007-6424?
Comment 6 Sonja Krause-Harder 2008-03-26 09:07:29 UTC
CVE-2007-6423 only affects apache on windows (see original report and http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2007-6423), the discussion about the fix for CVE-2007-6420 has resulted in a final patch yet and I didn't want to wait for that.
Comment 7 Ludwig Nussel 2008-03-26 09:36:47 UTC
s/has resulted/hasn't resulted/ I suppose.
So I'll close this bug as fixed and open a new one with the pending issue so we don't forget about it.
Comment 9 Thomas Biege 2009-10-14 00:27:11 UTC
CVE-2007-6424: CVSS v2 Base Score: 4.3 (AV:N/AC:M/Au:N/C:N/I:P/A:N)